new_web/urls.py
from django.contrib import admin
from django.urls import path, include
from story6 import urls as story

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(story)),
]

story6/urls.py
from django.urls import path
from .views import index, profile, books, books_api, subscribe, check_email, add_subscriber, subscriber_data, unsubscribe, login, logout

app_name = 'story6'
urlpatterns = [
    path('', index, name='index'),
    path('profile/', profile, name = 'profile'),
    path('books/', books, name = 'books'),
    path('books/api/library/<str:tema>/', books_api, name='books_api'),
    path('subscribe/', subscribe, name='subscribe'),
    path('add_subscriber/', add_subscriber, name='add_subscriber'),
    path('check_email/', check_email, name='check_email'),
    path('subscriber_data/', subscriber_data, name='subscriber_data'),
    path('unsubscribe/', unsubscribe, name='unsubscribe'),
    path('login/', login, name='login'),
    path('logout/', logout, name='logout'),
    path('auth/', include('social_django.urls', namespace='social')),
]

story6/models.py
from django.db import models

# Create your models here.
class Status (models.Model):
    name = models.CharField(max_length=20)
    status = models.CharField(max_length=300)
    time = models.DateTimeField(auto_now_add=True)

class Subscribe (models.Model):
    name = models.CharField(max_length=20)
    email = models.EmailField(max_length=100)
    password = models.CharField(max_length = 100)

story6/forms.py
from django import forms

class Status_Form(forms.Form):
    error_message = {
        'required': 'Please fill in'
    }

    name_attrs = {
        'type': 'text',
        'class': 'form-control',
        'placeholder': 'Your Name',
        'id': 'name-form'
    }
    stat_attrs = {
        'type': 'text',
        'class': 'form-control',
        'placeholder': "What's on your mind?",
        'id': 'status-form'
    }

    name = forms.CharField(label='Name', required=True, max_length=50,
    widget=forms.TextInput(attrs=name_attrs))
    status = forms.CharField(label='Status', required=True, max_length=300,
    widget= forms.TextInput(attrs=stat_attrs))

class Subscribe_Form(forms.Form):
    error_message = {
        'required': 'Please fill in'
    }

    subsname_attrs = {
        'type': 'text',
        'class': 'form-control',
        'placeholder': 'Your Name',
        'id': 'subsname-form'
    }
    email_attrs = {
        'type': 'type',
        'class': 'form-control',
        'placeholder': "yourname@mail.com",
        'id': 'email-form'
    }
    pass_attrs = {
        'type': 'password',
        'class': 'form-control',
        'placeholder': "Type your password here",
        'id': 'pass-form'
    }

    name = forms.CharField(label='Name', required=True, max_length=50,
    widget=forms.TextInput(attrs=subsname_attrs))
    email = forms.CharField(label='Email', required=True, max_length=100,
    widget= forms.EmailInput(attrs=email_attrs))
    password = forms.CharField(label='Password', required=True, max_length=50,
    widget=forms.PasswordInput(attrs=pass_attrs))

story6/views.py
from django.shortcuts import render
from .forms import Status_Form, Subscribe_Form
from .models import Status, Subscribe
from django.http import JsonResponse, HttpResponse
import urllib.request, json
import requests
from django.core.validators import validate_email
from django.views.decorators.csrf import csrf_exempt

# Create your views here.
response = {}
def index(request):
    response['status_form'] = Status_Form
    the_status = Status.objects.all()
    response['Status_Form'] = the_status

    form = Status_Form(request.POST or None)
    if(request.method == 'POST'  and form.is_valid()):
        response['name'] = request.POST['name'] if request.POST['name'] != "" else "Anonymous"
        response['status'] = request.POST['status']
    
        the_status = Status(name=response['name'], status=response['status'])
        the_status.save()
    
        return render(request, 'hello.html', response)
    else:
        return render(request, 'hello.html', response)

def profile(request):
    return render(request, 'profile.html')

def books(request):
    return render(request, 'books.html')

def books_api(request, tema):
    api = requests.get('https://www.googleapis.com/books/v1/volumes?q=' + tema).json()
    book_items = []

    for i in api['items']:
        data = {}
        data['thumbnail'] = i['volumeInfo']['imageLinks']['thumbnail'] if 'imageLinks' in i['volumeInfo'].keys() else 'Not available'
        data['title'] = i['volumeInfo']['title']
        data['authors'] = ", ".join(i['volumeInfo']['authors']) if 'authors' in i['volumeInfo'].keys() else 'Not available'
        book_items.append(data)
    return JsonResponse({"data" : book_items})

def subscribe(request):
    response['subscribe_form'] = Subscribe_Form
    html = 'subscribe.html'
    return render(request, html, response)

def check_email(request):
    try:
        print(request.POST['email'])
        validate_email(request.POST['email'])
    except:
        return JsonResponse({
            'message' : 'E-mail format is wrong!',
            'status' : 'fail'
        })
    
    existed = Subscribe.objects.filter(email=request.POST['email'])

    if(existed):
        return JsonResponse({
            'message': "E-mail is already registered",
            'status': 'fail'
        })
    else:
        return JsonResponse({
            'message': "E-mail is valid",
            'status': 'success'
        })

def add_subscriber(request):
    if (request.method == "POST"):
        subscribe = Subscribe(
            name = request.POST['name'],
            email = request.POST['email'],
            password = request.POST['password']   
        )
        subscribe.save()

        return JsonResponse({
            'message':'Subcription success! :)'
        }, status = 200)

    else:
        return JsonResponse({
            'message':"Subcription failed! :("
        }, status = 403)

def subscriber_data(request):
    data = list(Subscribe.objects.all().values('pk', 'name', 'email', 'password'))
    return JsonResponse({'datas': data})

@csrf_exempt
def unsubscribe(request):
    if request.method == 'POST':
        data = request.POST['pk']
        Subscribe.objects.filter(pk=data).delete()
        return HttpResponse({'status':'Success'})
    else:
        return HttpResponse({'status':'Failed to load page'})

@csrf_exempt
def auth_code(request):
    return JsonResponse({"user" : code})

story6/templates/books.html
{% extends 'navbar.html' %}
{% load static %} <!-- load files from static folder-->

{% block content %}
<header class="container">
    <div class="row text-center">
        <h1>Little Library</h1>
    </div>
</header>

<div class="container" id="profile">
    <div class="row text-left">
        <h3 id="favorites"><i class ="fa fa-star" style="font-size: 27px;color:#22223B"></i> My Favorites: <span class="counters">0</span></h3>
    </div>
    <div class="row">
        <div class="col">
            <a class="btn btn-outline-primary" id="architecture">Architecture</a>
            <a class="btn btn-outline-primary" id="comic">Comic</a>
            <a class="btn btn-outline-primary" id="quilting">Quilting</a>
        </div>
    </div>
    <div class="row">
        <table class="table">
            <thead><tr>
                <th scope="col">No</th>
                <th scope="col"> Cover</th>
                <th scope="col">Title</th>
                <th scope="col">Author</th>
                <th scope="col"> Favorites</th>
            </tr></thead>

            <tbody></tbody>
        </table>    
    </div>
</div>

{% endblock content %}

story6/templates/hello.html
{% extends 'navbar.html'%}
{% load static %} <!-- load files from static folder-->

{% block content %}

{% if user.is_authenticated %}
<p class="display-4">Hello, {{ user.username }}</p>
{% else %}
<a class="lead" href="{% url 'login' %}">Log in</a>
{% endif %}

<header class="container">
    <div class="row text-center">
        <h1>Hello, Apa Kabar?</h1>
    </div>
</header>

<section name="input-status">
    <div class="container">
        <form class="form-group" id="form" method="POST" action="{% url 'story6:index' %}">
                <h4>Input your status here: </h4>
                <div >
                    {% csrf_token %}
                    {% for i in status_form %}
                        {{i.label_tag}}
                        <br>
                        {{ i }}
                    {% endfor %}
                </div>
                <button class="form-group" id="buttons" types="submit">Submit</button>
            </form>
    </div>
</section>

<section name="status">
    <div class="container">
        <div class="row">
            <table class="table">
                <thead>
                    <th>Name</th>
                    <th>Status</th>
                    <th>Time</th>
                </thead>
                <tbody>
                    {% for i in Status_Form %}
                    <tr>
                        <td> {{i.name}} </td>
                        <td> {{i.status}} </td>
                        <td> {{i.time}} </td>
                    </tr>             
                    {% endfor %}
                </tbody>
            </table>
        </div>
    </div>
</section>

{% endblock content %}

story6/templates/login.html
{% extends 'navbar.html'%}
{% load static %} <!-- load files from static folder-->

{% block content %}
  <h2>Login</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button id="buttons" type="submit">Login</button>
  </form>
   <br>
  <p><strong>-- OR --</strong></p>
  <a href="{% url 'social:begin' 'google-oauth2' %}">Login with Google</a><br>
  <p><strong>-- OR --</strong></p>
{% endblock %}

story6/templates/navbar.html
{% load static %} <!-- load files from static folder-->

<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Little Journey</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" media="screen" href="{% static 'css/main.css' %}" />
    <script type="text/Javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script type="text/Javascript" src="{% static 'js/main_js.js' %}"></script>
</head>
<body>
    <div class="container">
        <nav class="navbar navbar-inverse navbar-fixed-top">
            <div class="container-fluid">
                <div class="navbar-header">
                    <a class="navbar-brand" href="#">Little Journey</a>
                </div>
                <ul class="nav navbar-nav">
                    <li class="active"><a href="../">Home</a></li>
                    <li><a href="../profile">Profile</a></li>
                    <li><a href="../books">Books</a></li>
                </ul>
                <ul class="nav navbar-nav navbar-right">
                    <li><a href="../subscribe">Subscribe</a></li>
                    <li class="active" id="themes">Theme</li>
                </ul>
            </div>
        </nav>
    </div>

    <div class="container">
        {% block content %}{% endblock %}
    </div>

</body>
</html>

story6/templates/profile.html
{% extends 'navbar.html' %}
{% load static %} <!-- load files from static folder-->

{% block content %}
<header class="container">
    <div class="row text-center">
        <h1>Know Me Better</h1>
    </div>
</header>

<div class="container" id="profile">
    <!--splash page-->
    <div id="overlay">
        <div class="text-center" id="overlay-content">Please wait, the page is loading...</div>
    </div>

    <!--image-->
    <div class="row text-center">
        <img src="https://scontent.fcgk4-2.fna.fbcdn.net/v/t1.0-9/6879_1823849061175539_4264076232258924834_n.jpg?_nc_cat=103&oh=9e2f0fe197ce38cc2ab0f48919805292&oe=5C23187C">
    </div>

    <!--description-->
    <div class="row">
        <p>Yasmin Amalia. Born March 10, 1998. Indonesian by blood, Washingtonian by heart. Student by day, programmer by night.
            Books, sweets, and sunsets are my favorite ones.
        </p>
    </div>

    <div class="row">
        <br>
        <br>
    </div>

    <!--accordions-->
    <div class="row">
        <div class="accordions">
                <button class="accordion">Activities</button>
                <div class="panel">
                    <p>
                        <li>Studying</li>
                        <li>Praying</li>
                        <li>Coding</li>
                    </p>
                </div>
        
                <button class="accordion">Organizations</button>
                <div class="panel">
                    <p>
                        <li>DPM Fasilkom UI</li>
                    </p>
                </div>

                <button class="accordion">Achievements</button>
                <div class="panel">
                    <p>
                        <li>Surviving in Fasilkom untill now</li>
                    </p>
                </div>
        </div>
    </div>
</div>

{% endblock content %}

story6/templates/subscribe.html
{% extends 'navbar.html'%}
{% load static %} <!-- load files from static folder-->

{% block content %}

<header class="container">
    <div class="row text-center">
        <h1>Be My Friend?</h1>
    </div>
</header>

<section name="subscribe-content">
    <div class="container">
        <form class="form-group" id="form" method="POST">
                <h4>Subscribe here: </h4>
                <div>
                    {% csrf_token %}
                    {{subscribe_form}}
                </div>
                <div id="status"></div>
                <button class="form-group" id="submit" types="submit" disabled>Submit</button>
            </form>
    </div>
</section>

<section name="subcriber-list">
    <div class="container">
        <centre>
            <table class="table" id="subscriber-table">
                <tr>
                    <thead>
                        <th scope="col">No</th>
                        <th scope="col">Name</th>
                        <th scope="col"> Email</th>
                        <th scope="col"> Unsubscribe</th>
                    </thead>
                </tr>
                <tbody></tbody>
             </table>   
        </centre>
    </div>
</section>

{% endblock content %}